#include <PinChangeInt.h>    //外部中断
#include <MsTimer2.h>        //定时中断
#include <DATASCOPE.h>      //这是PC端上位机的库文件

//The sample code for driving one way motor encoder
const byte encoder0pinA = 2; //A pin -> the interrupt pin 0
const byte encoder0pinB = 4; //B pin -> the digital pin 4
const byte rencodPinA = 3;  //rencodPinA -> the interrupt pin 1
const byte rencodPinB = 7;  //rencodPinB -> the digital pin 11

#define IN1  8    //left motor direction
#define IN2  9    //left motor direction
#define IN3  10   //right motor direction
#define IN4  12   //right motor direction
#define ENA  5    //Needs to be a PWM pin to be able to control motor speed ENA
#define ENB  6    //Needs to be a PWM pin to be able to control motor speed ENB
#define motorspeed   200
const float Kp =20;
const float Ki =1;
byte encoder0PinALast,encoder0PinALast1;
int duration,duration1;//the number of the pulses
boolean l_direction,r_direction; //the rotation direction 
int master_pulse,slave_pulse;
int pwm;
static int i;
unsigned char Send_Count;
DATASCOPE data; //实例化一个 上位机 对象，对象名称为 data
void DataScope(void)
{
  int i;
  data.DataScope_Get_Channel_Data(-1*master_pulse-slave_pulse, 1); //显示第二个数据，左轮速度  也就是每40ms输出的脉冲计数
  data.DataScope_Get_Channel_Data(0, 2); //显示第二个数据，左轮速度  也就是每40ms输出的脉冲计数
  data.DataScope_Get_Channel_Data(pwm, 3); //显示第三个数据，右轮速度 也就是每40ms输出的脉冲计数
  data.DataScope_Get_Channel_Data(slave_pulse, 4); //显示第三个数据，右轮速度 也就是每40ms输出的脉冲计数
  Send_Count = data.DataScope_Data_Generate(4); 
  for ( i = 0 ; i < Send_Count; i++)
  {
    Serial.write(DataScope_OutPut_Buffer[i]);  
  }
  delay(50);  //上位机必须严格控制发送时序
}

void go_ahead()
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, HIGH);
  digitalWrite(IN3, LOW);
  digitalWrite(IN4,HIGH);
}
void go_back()
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4,LOW); 
}
void go_stop()
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, LOW);
  digitalWrite(IN3, LOW);
  digitalWrite(IN4,LOW); 
}
void setup()
{  
  pinMode(IN1, OUTPUT); 
  pinMode(IN2, OUTPUT); 
  pinMode(ENA, OUTPUT);  
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT); 
  pinMode(ENB, OUTPUT); 

  
  Serial.begin(128000);//Initialize the serial port
  /*encoder init*/
  l_direction = true;//default -> Forward  
  r_direction = true;
  pinMode(encoder0pinB,INPUT);  
  pinMode(rencodPinB,INPUT);  
  attachInterrupt(0, lwheelSpeed, CHANGE);
  attachInterrupt(1, rwheelSpeed, CHANGE);
  
  delay(1500);              //延时等待初始化完成
  MsTimer2::set(10, control);  //使用Timer2设置10ms定时中断
  MsTimer2::start();          //使用中断使能
  analogWrite(ENA,motorspeed),analogWrite(ENB,motorspeed); 
}
int PID_controller(int master,int slave)
{ 
  static float power,error,integralerror,lasterror;
  if(master < 0) master = -master;
  if(slave < 0) slave = -slave;
  error = master - slave;
  integralerror += error;
  power += Kp *(error-lasterror) + Ki * error;
  lasterror = error;
  return power;
}

void control()
{
   sei();//enable global interrupts
   if(++i >=4)//20ms
   {
   master_pulse = duration ,duration = 0;
   slave_pulse = duration1, duration1 = 0;
   pwm = PID_controller(master_pulse,slave_pulse);
   i = 0;
   }
   int newpower1 = motorspeed+pwm;
   constrain(newpower1,0,255);
   analogWrite(ENB,newpower1),analogWrite(ENA,motorspeed);
   cli();//disenable global interrupts
}
void loop()
{
  go_ahead();
  Serial.begin(128000), DataScope(); //使用上位机时，波特率是128000
}
 
void lwheelSpeed()
{
  int Lstate = digitalRead(encoder0pinA);
  if((encoder0PinALast == LOW) && Lstate==HIGH)
  {
    int val = digitalRead(encoder0pinB);
    if(val == LOW && l_direction)
    {
      l_direction = false; //Reverse
    }
    else if(val == HIGH && !l_direction)
    {
      l_direction = true;  //Forward
    }
  }
  encoder0PinALast = Lstate;
 
  if(!l_direction)  duration++;
  else  duration--;
}

void rwheelSpeed()
{
  int Lstate = digitalRead(rencodPinA);
  if((encoder0PinALast1 == LOW) && Lstate==HIGH)
  {
    int val = digitalRead(rencodPinB);
    if(val == LOW && r_direction)
    {
      r_direction = false; //Reverse
    }
    else if(val == HIGH && !r_direction)
    {
      r_direction = true;  //Forward
    }
  }
  encoder0PinALast1 = Lstate;
 
  if(!r_direction)  duration1++;
  else  duration1--;
}

